<?php

namespace Drupal\cmlapi\Controller;

use Drupal\Core\Controller\ControllerBase;
use Symfony\Component\Yaml\Yaml;

/**
 * Product Variations route.
 */
class ProductVariation extends ControllerBase {

  /**
   * Page import.
   */
  public function page($cml) {
    $cid = $cml;
    $result = __CLASS__;
    $result .= "<br>id={$cid}";
    $data = \Drupal::service('cmlapi.parser_offers')->parseArray($cid);
    if ($data) {
      $svoistvo = Yaml::dump($this->preparesvoistvo($data['svoistvo']), 5);
      $offer = Yaml::dump($this->prepareOffer($data['offer'], $data['svoistvo']), 7, 1, FALSE, TRUE);
      return [
        'svoistvo' => ['#markup' => "<pre>$svoistvo</pre>"],
        'category' => ['#markup' => "<pre>$offer</pre>"],
      ];
    }
    return [
      '#markup' => $this->t('No data'),
    ];

  }

  /**
   * Json import.
   */
  public function preparesvoistvo($svoistvos) {
    $result = [];
    if (!empty($svoistvos)) {
      $svoistvos = \Drupal::service('cmlapi.xml_parser')->arrayNormalize($svoistvos);
      foreach ($svoistvos as $svoistvo) {
        $id = $svoistvo['Ид'];
        $name = $svoistvo['Наименование'];
        if ($svoistvo['ТипЗначений'] == 'Справочник') {
          $sprav = [];
          if (isset($svoistvo['ВариантыЗначений']['Справочник'])) {
            $sprav = \Drupal::service('cmlapi.xml_parser')->xml2Val($svoistvo['ВариантыЗначений']['Справочник']);
          }
          $result['taxonomy']["$name"] = $sprav;
        }
        else {
          $result['field']["$name"] = $svoistvo['Значение'];
        }
      }
    }
    return $result;
  }

  /**
   * Json import.
   */
  public function prepareOffer($offers, $svoistvos) {
    $result = [];
    $fields = [];
    $svoistvos = \Drupal::service('cmlapi.xml_parser')->arrayNormalize($svoistvos);
    foreach ($svoistvos as $svoistvo) {
      $id = $svoistvo['Ид'] ?? '';
      if (!empty($svoistvo['ВариантыЗначений']['Справочник'])) {
        $vocabulary = \Drupal::service('cmlapi.xml_parser')->arrayNormalize($svoistvo['ВариантыЗначений']['Справочник']);
        foreach ($vocabulary as $kay => $value) {
          $fields[$id][$value['ИдЗначения']] = $value['Значение'];
        }
      }
    }
    if (!empty($offers)) {
      if (!empty($offers['Ид'])) {
        $offers = \Drupal::service('cmlapi.xml_parser')->arrayNormalize($offers);
      }
      foreach ($offers as $offer) {
        $id = $offer['Id'];
        $name = $offer['Naimenovanie'];
        $svoistvo = [];
        if (!empty($offer['ZnacheniyaSvoystv'])) {
          foreach ($offer['ZnacheniyaSvoystv'] as $kay => $value) {
            $offer['ZnacheniyaSvoystv'] = $fields[$kay][$value];
          }
        }
        $result[$id] = $offer;
      }
    }
    return $result;
  }

}
